# ntpsnmpd - NTP SNMP AgentX daemon

| from Pogo, Walt Kelly

## 1. Manual Pages

### 1.1. Manual Pages

- `ntp.conf(5)` - ntpd Configuration File

- `ntp.keys(5)` - NTP symmetric key file format

- `ntpd(8)` - Network Time Protocol (NTP) daemon

- `ntpdig(1)` - Simple Network Time Protocol (SNTP) client

- `ntpfrob(8)` - frob the local clock hardware

- `ntpkeygen(8)` - generate public and private keys

- `ntpleapfetch(8)` fetch and manage leap-offset file

- `ntploggps(1)` - log gpsd data for use by ntpviz

- `ntplogtemp(1)` - log system temperature data for use by ntpviz

- `ntpmon(1)` - real-time NTP status monitor

- `ntpq(1)` - standard NTP query program

- `ntpsnmp(1)` - an AgentX Simple Network Management Protocol sub-agent [`experimental`]

- `ntpsweep(1)` - print information about given NTP servers

- `ntptime(8)` - read and set kernel time variables

- `ntptrace(1)` - trace a chain of NTP servers back to the primary source

- `ntpviz(1)` - make offset, jitter, and other plots from logfiles

- `ntpwait(8)` - wait until ntpd is in synchronized state

## 2. Synopsis

`ntpsnmpd` [`-nxdDlhV`] [ntp host]

## 3. Description

`[experimental]`

`ntpsnmpd` is an AgentX Simple Network Management Protocol sub-agent.

It functions as a bridge between the Mode 6 protocol used for Network Time Protocol monitoring, and an SNMP master agent. The user must have running NTP and SNMP daemons for ntpsnmpd to work.

## 4. Options

`-c` filename, `--configfile`=filename

  Alternate path for the configuration file, /etc/ntpsnmpd.conf by default

`-n`, `--nofork`

  Do not fork

`-x`, `--master-addr`

  Specify address for connecting to the master agent

`-d`, `--debug`

  Increase debugging level by 1.

`-D` num, `--set-debug-level`=num

  The debug level is set to the following integer argument.

`-l` filename, `--logfile`=filename

  Log debugging output to the specified file.

`-h`, `--help`

  Print a usage message summarizing options end exit.

`-V`, `--version`

  Print the version string and exit.

## 5. Configuration Files

    Note that filenames in the options should be enclosed in quotes.
    This is a temporary measure that will not be the case in future
    versions.

### 5.1. /etc/ntpsnmpd.conf

`master-addr` addr

  The address of the SNMP master agent to connect to. Can be either a named socket or an IP address / hostname and port number.

`ntp-addr` addr

  The address of the NTP daemon to monitor.

`logfile` filename

  Log debugging output to the specified file.

`loglevel` level

  Threshold for log messages. Equivalent to -D

### 5.2. /var/ntpsnmpd/notify.conf

    This file is used to store the state of options that can be set
    by writing to certain OIDs. Any comments will be overwritten by
    ntpsnmpd upon write.

`notify-mode-change` [ True | False ]

  Enable notifications on ntpd mode change.

`notify-stratum-change` [ True | False ]

  Enable notifications on NTP stratum change.

`notify-syspeer-change` [ True | False ]

  Enable notifications when ntpd selects a new system peer.

`notify-add-association` [ True | False ]

  Enable notifications when ntpd adds a new peer.

`notify-rm-association` [ True | False ]

  Enable notifications when ntpd removes a peer.

`notify-leap-announced` [ True | False ]

  Enable notifications on leap second announcement.

`notify-heartbeat` [ True | False ]

  Send heartbeat notification.

`heartbeat-interval` interval

  Frequency of heartbeat notification in integer seconds.

## 6. Known Limitations

This program is still experimental in nature. Parts of the AgentX standard are not yet fully implemented, logging not fleshed out yet, some options missing, etc.

## 7. Known Deviations from RFC 5907

The ntpEntStatusEntityUptime OID specifies a bizarre time format. This does not match what the SNMP tools expect to see from a TimeTicks variable. Instead the daemon returns a normal TimeTicks value.

The ntpEntNotifConfigChanged trap is left unimplemented. This is because there currently is no way to implement what it wants, and it demands alerts regarding changes that are not part of NTP’s jurisdiction.

The ntpEntTimeResolution OID currently uses data from the sys_fuzz variable as the base for it’s calculations. It is by no means certain that this is the correct choice, and the returned data should be taken with scepticism.

The ntpEntStatPktModeTable is unimplemented due to not currently having a data source.

## 8. Mode 6 Protocol

The Mode 6 protocol used by ntpsnmpd to communicate with ntpd is described here.

Home Page | Site Map | Contacts